use std::io::{self, stdout, Stdout};
use ratatui::{
	backend::CrosstermBackend,
		crossterm::{
			execute,
			terminal::{
				disable_raw_mode,
				enable_raw_mode,
				EnterAlternateScreen,
				LeaveAlternateScreen,
			},
			event::{
				EnableMouseCapture,
				DisableMouseCapture,
			},
	},
	Terminal,
};

pub type Tui = Terminal<CrosstermBackend<Stdout>>;

pub fn init() -> io::Result<Tui> {
	execute!(stdout(), EnterAlternateScreen)?;
	execute!(stdout(), EnableMouseCapture)?;
	enable_raw_mode()?;
	Terminal::new(CrosstermBackend::new(stdout()))
}

pub fn restore() -> io::Result<()> {
	execute!(stdout(), LeaveAlternateScreen)?;
	execute!(stdout(), DisableMouseCapture)?;
	disable_raw_mode()?;
	Ok(())
}

